//
// file : aiState_predictApproaching.cpp
//

#include <Windows.h>
#include "aiState.h"
#include "aiContoller.h"
//#include "../../_commonSrc/physics/math.h"

void cAI_state_predictApproaching::enter()
{
	m_bPositionNotReachable = false;
}


void cAI_state_predictApproaching::update(float t)
{
	// the ball is moving toward us
	cNPC_controller *parent = (cNPC_controller*)m_parent;

	/* octaball source grab....
	// check if ball is currently heading into the goal and was last touched by the ai
	if(parent->m_theBall->id = AI)
	{
		cVector vecBallToGoal = parent->m_theGrid->ptBoundsMid[parent->m_theGrid->goalSegment].minus(parent->m_theBall->pos);
		vecBallToGoal.normalize();
	
		float cosAngle = vecBallToGoal.dot(parent->m_theBall->dir);
		if((cosAngle < 0.1f) && (cosAngle > -0.1f))
		{
			// simple hack...stays out of the way but rarely moves out of the way
			// try not to let the ai block its own upcoming goal 
			parent->m_vecKnownBallCollisionPos = cVector(0, 0);
			parent->m_theActor->dir = parent->m_vecKnownBallCollisionPos.minus(parent->m_theActor->pos);
			parent->m_theActor->dir.normalize();
			return;
		}
	}
	*/

	/*/ calculate the collision position and see if it's approachable in time
	// do an early out before calculating a refined position
	cVector2 desiredPos;
	if(physics::projectOnLineVector(parent->m_theActor->pos, parent->m_theBall->pos, parent->m_theBall->dir, &desiredPos) == false)
	{
		m_bPositionNotReachable = true;
		return;
	}
	
	// calculate the adjusted bounce position
	cVector2 vecToGoal = parent->m_theGrid->ptBoundsMid[parent->m_theGrid->goalSegment] - desiredPos;
	vecToGoal.normalize();
	cVector2 vecToBall = parent->m_theBall->dir.inverse(); // direction when at the collision position

	// this is the cheat magic number
	// change to adjust the accuracy of the ai aiming ability 
	float scalar = 0.46235f;

	float angleScaled = acos(cVector2::dot(vecToBall, vecToGoal)) * scalar; 
	float moveDistance = (parent->m_theActor->radius + parent->m_theBall->radius) * angleScaled;  

	// get the perpendicular to the ball vector
	cVector2 moveVec;
	moveVec.x = -parent->m_theBall->dir.y;
	moveVec.y =  parent->m_theBall->dir.x;
	if(cVector2::dot(moveVec, vecToGoal) > 0)
	{
		// pointing in the same direction, swap the direction of the moveVec
		moveVec.x = -moveVec.x;
		moveVec.y = -moveVec.y;
	}
	desiredPos = desiredPos.addScaled(moveVec, moveDistance);
	
	if(parent->m_theGrid->test_isPositionInPlay(desiredPos, parent->m_theActor->radius))
	{
		// the desired position is in the playable area
		parent->m_vecKnownBallCollisionPos = desiredPos;
		parent->m_theActor->dir = desiredPos - parent->m_theActor->pos;
		parent->m_theActor->dir.normalize();
	}*/
}


eAI_state cAI_state_predictApproaching::checkTransition(float t)
{
	cNPC_controller *parent = (cNPC_controller*)m_parent;

	if(m_bPositionNotReachable == true)
		return FSM_STATE_IDLE;

	return FSM_STATE_APPROACH;
}


void cAI_state_predictApproaching::exit()
{
	// do any last chance state changes
}