//#pragma once

//
// Warning : Hack Module
//           (we stick it, we yank it out)
//


namespace foo
{
	struct Hex
	{
		float r = 16.2f; // even numbers only?
		float hr = r * 0.5f;
		vec2 pos = { 0.f, 0.f };
		vec2 stride = { 1.5f*r, 1.f*r };
		olc::Pixel color = olc::Pixel(25, 75, 125, 255);

		int hexLights[14][12] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
								  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,   
								  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
								  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
								  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

		void draw(vec2 offset, olc::PixelGameEngine* e)
		{
			float sign = 1.f;
			// draw hex grid 22 x 16 at radius r
			for (int j = 0; j < 14; ++j)
			{
				vec2 vo = offset;
				for (int i = 0; i < 12; ++i)
				{
					float rnd = (float)rand() / (float)RAND_MAX;
					rnd > 0.999f ? hexLights[i][j] = 1 : rnd < 0.01 ? hexLights[i][j] = 0 : 0;
					hexLights[i][j] == 1 ? color = olc::YELLOW : color = olc::Pixel(25, 75, 125, 255);
					vec2 p = pos + vo; // start position (0, 0)
					e->DrawLine(p.x + hr, p.y - r, p.x + r, p.y, color);
					e->DrawLine(p.x + r, p.y, p.x + hr, p.y + r, color);
					e->DrawLine(p.x + hr, p.y + r, p.x - hr, p.y + r, color);
					vo.x += stride.x;
					vo.y += stride.y * sign;
					sign *= -1.f; // better flip???
				}
				offset += vec2(0.f, 2.0f*r);
			}
		}
	};

	struct graph
	{
		vec2 pos = { 0.f, 0.f };
		olc::Pixel color = olc::Pixel(0, 255, 0, 255);

		float A = 0.f; // amplitude
		float f = 0.f; // frequency
		float get(int t) { return A * sinf(f*t) + A; }

		// vec2 offset - screen position
		// float start_t - start time
		// float len_t - length of time
		// int pix - number of pixels for this time slice
		void draw(vec2 offset, float start_t, float len_t, int pix, olc::PixelGameEngine* e)
		{	// draw sin wave
			vec2 p = { 0.f, 0.f };
			for (int i = 0; i < pix; i++)
			{	// each horizontal pixel 
				p = pos + offset;
				p.x += i;
				p.y += get(i);
				e->Draw(p.x, p.y, color);
			}
		}
	};
}