//
// file : state_enum.h
//

#ifndef _STATE_ENUM_H_
#define _STATE_ENUM_H_

enum eAI_state
{
	FSM_STATE_NONE     = 0,
	FSM_STATE_IDLE     = 1,
	FSM_STATE_RESET    = 2,
	FSM_STATE_SEARCH   = 3,
	FSM_STATE_APPROACH = 4,
	FSM_STATE_APPROACH_CHARACTER = 5,
	FSM_STATE_APPROACH_BUMPER      = 6,
	FSM_STATE_APPROACH_PIPE        = 7,
	FSM_STATE_DRIVE_PIN            = 8,
	FSM_STATE_ATTACK_BUMPER        = 9,
	FSM_STATE_ATTACK_PATTERN_ALPHA = 10,
	FSM_STATE_ATTACK_PATTERN_BETA  = 11,
	FSM_STATE_ATTACK_PATTERN_DELTA = 12,
	FSM_STATE_PREDICT_APPROACHING = 13,
	FSM_STATE_PREDICT_RETREATING = 14,
	FSM_STATE_COUNT = 15
};

enum eAI_machine
{
	FSM_MACH_NONE = 0,
	FSM_MACH_NPC,
	FSM_MACH_COUNT
};

#endif//_STATE_ENUM_H_
