#pragma once
#include "../AI/aiContoller.h"

class SuperPooper
{
public:
	/*int keyCount[3] = { 1, 5, 4 }; // this thing...don't touch :| will break ai key advance if not reset per key.

	KeyFrame motion_attack01[3] = { {4.f, 350.f, 105.f, 1}, {6.f, 400.f, 80.f, 0}, {8.f, 500.f, 115.f, 0} };
	KeyFrame motion_attack02[5] = { {1.f, 400.f, 20.f, 0}, {3.f, 400.f, 40.f, 1}, {5.f, 400.f, 60.f, 2}, {7.f, 400.f, 80.f, 1}, {9.f, 400.f, 100.f, 2} };
	KeyFrame motion_idle[4] = { {2.f, 420.f, 30.f, 0}, {4.f, 350.f, 90.f, 0}, {6.f, 420.f, 150.f, 0}, {8.f, 490.f, 90.f, 0} };

	enum eMotionID
	{
		attack01,
		attack02,
		idle
	};
	// perceptions
	bool isPlayerMoving = false;
	bool isAttacking_02 = false;
	float tension = 0.f; // horizontal signed distance away from player
	
	float radius_aware = 40;
	*/
	

public:
	SuperPooper() {	}

	BallFactory objFactory;
	BallGoal objGoalPin;

	cNPC_controller ai;


	//KeyFrame* currentMotion;
	//eMotionID motionID; 


	KeyFrame lastKey;
	KeyFrame nextKey;
	float currentTimeSlice = 0.f;
	//int key = 0;
	


	void init()
	{ 
		objFactory.pos = { 830.f, 40.f }; // start position

		// todo : set perception

		ai.initialize();
		
		lastKey.t = 0.f;
		lastKey.px = objFactory.pos.x;
		lastKey.py = objFactory.pos.y;
		lastKey.aux = 0;

		//currentMotion = motion_attack01;
		//motionID = eMotionID::attack01;
		//nextKey = currentMotion[motionID];

		// -- TODO :: ???next key
	}


	float lerp(float p1, float p2, float t) { return (1 - t) * p1 + t * p2; }
	int update(float dt, std::list<std::unique_ptr<PhysicsObject>> &physicsObjs)
	{
		ai.update(dt);

		/*if (abs(tension) < 50.f) {
			if (isAttacking_02 == false)
			{
				currentTimeSlice = nextKey.t;
				currentMotion = motion_attack02;
				motionID = eMotionID::attack02;
				isAttacking_02 = true;
			}
		}
		else {
			if (isPlayerMoving && isAttacking_02)
			{
				currentTimeSlice = nextKey.t;
				currentMotion = motion_attack01;
				motionID = eMotionID::attack01;
				isAttacking_02 = false;
			}
		}*/

		






		int auxTrigger = 0; // pass value through

		// update the ball pooper position from keyframe data
		if (objFactory.isMoving)
		{
			currentTimeSlice += dt;                         // advance animation timer
			if (currentTimeSlice > nextKey.t)               // the key expired?
			{	// advance key
				auxTrigger = nextKey.aux;                   // activate trigger on this frame end
				lastKey = nextKey;
				//key++;

				/*if (key == keyCount[motionID]) 
				{
					lastKey.t = 0;
					key = 0;                             // finished it. do idle ??? something different???
					currentTimeSlice = 0.f;              // full on ai ....pfffttt....
				}*/
				
				nextKey = ai.getNextKey();// currentMotion[key];// motion_idle[key];
				currentTimeSlice = 0.f; // we restart every time now until duration
				lastKey.t = 0.f;
			}








			float thisTime = (currentTimeSlice - lastKey.t) / (nextKey.t - lastKey.t); // 0 --> 1
			if (thisTime < 0) thisTime = 0; // are these ever called???
			if (thisTime > 1) thisTime = 1; // keep for edge
			float nextPosX = lerp(lastKey.px, nextKey.px, thisTime);
			float nextPosY = lerp(lastKey.py, nextKey.py, thisTime);
			objFactory.vel.x = (nextPosX - objFactory.pos.x);
			objFactory.vel.y = (nextPosY - objFactory.pos.y);
			objFactory.pos.x = nextPosX;
			objFactory.pos.y = nextPosY;

			if (objGoalPin.isCarried)
			{
				objGoalPin.pos.x = nextPosX;
				objGoalPin.pos.y = nextPosY + 20;
			}

				// fire ray check here???
			                                           // this -------->>>   // fake it in the movement scripting??? (leaning here)

			//objGoalPin.isCarried = false;                                   // potential behavior trigger
		
			/*vec2 viewWorldPos = { objFactory.pos.x, objFactory.pos.y };
			Dummy* p = new Dummy(viewWorldPos.x, viewWorldPos.y);
			p->nextPos = p->pos;
			p->nextVel = p->vel = { -3.f, 0.f };                              // good ball launch algo
			p->id = physicsObjs.size();
			physicsObjs.push_back(std::unique_ptr<Dummy>(p));*/
		}
		

		if (ai.fireThisFrame > 0) { int result = ai.fireThisFrame; ai.fireThisFrame = 0; return result; }
		return auxTrigger;
	}

	void draw(olc::PixelGameEngine* e, int cx, int cy)
	{
		objFactory.Draw(e, cx, cy);
		
		//e->DrawCircle(objFactory.pos.x - cx, objFactory.pos.y - cy, radius_aware, olc::DARK_RED);
	
		/*char buf[32] = "";
		_itoa_s(currentTimeSlice, buf, 10);
		e->DrawString(20, 200, buf);*/
	}

};