// file : introState.h

#ifndef _engine_core_states_intro_h_
#define _engine_core_states_intro_h_

#include "base_state.h"

namespace Core {
	namespace States {

		class Intro : public Base_state
		{

		public:
			Intro(void* _manager, vec2 _clientSize) : Base_state(_manager, "intro_state", _clientSize) { initialize(); }
			void initialize();
			void shutdown();

			void pause();
			void resume();

			void handleEvents();
			void update(float _deltaTime);
			void draw();

		private:
			
		};

	}
}

#endif
